//+------------------------------------------------------------------+
//|                                                  OnChart WPR.mq4 |
//|                                                           mladen |
//| not for sale, rent, auction, nor lease                           |
//+------------------------------------------------------------------+
// https://forex-station.com/viewtopic.php?p=1295413478#p1295413478
// modified by banzai; 6/26/20
// thanks to jeanlouie codes and templates @ https://www.forexfactory.com/jeanlouie

#property copyright "mladen"
#property link      "www.forex-station.com"

#property indicator_chart_window
#property indicator_buffers 12
#property indicator_color1  clrSlateGray // middle line
#property indicator_width1  1
#property indicator_style1  STYLE_DOT

#property indicator_color2  clrHotPink //upper band
#property indicator_width2  2
#property indicator_color3  clrHotPink  //lower band
#property indicator_width3  1

#property indicator_color4  clrSpringGreen //upper band
#property indicator_width4  2
#property indicator_color5  clrSpringGreen //lower band
#property indicator_width5  1

#property indicator_color6  clrSeaGreen //uptrend line
#property indicator_width6  3
#property indicator_color7  clrMediumVioletRed //downtrend line
#property indicator_width7  3
#property indicator_color8  clrMediumVioletRed //downtrend line
#property indicator_width8  3



extern string                TimeFrame         = "Current time frame";
extern double                WprPeriod         = 14;
extern double                WprPhase          = 0;
extern bool                  WprDouble         = false;
extern ENUM_APPLIED_PRICE    Price             =  0;
extern double                SmoothLength      = 50;
extern double                SmoothPhase       = 0; 
extern bool                  SmoothDouble      = false;
extern int                   AtrLength         = 120;
extern int                   overBought        = -20;
extern int                   overSold          = -80;
extern string                note9             = "-------------------------";
extern bool                  arrowsVisible     = true;
extern bool                  arrowsOnFirst     = true;
extern bool                  arrowsOnSlope     = true;
extern bool                  arrowsOnMaCross   = false;
extern double                arrowsUpperGap    = 1.0;
extern double                arrowsLowerGap    = 1.0;
extern color                 arrowsUpColor     = clrLimeGreen;
extern color                 arrowsDnColor     = clrRed;
extern int                   arrowsUpCode      = 241;
extern int                   arrowsDnCode      = 242;
extern int                   arrowsSize        = 3;
extern string                note10            = "-------------------------";
extern bool                  alertsOn          = false;
extern bool                  alertsOnCurrent   = false;
extern bool                  alertsOnSlope     = false;
extern bool                  alertsOnMaCross   = false;
extern bool                  alertsMessage     = false;
extern bool                  alertsSound       = false;
extern bool                  alertsNotify      = false;
extern bool                  alertsEmail       = false;
extern string                soundFile         = "alert2.wav";
extern bool                  MultiColor        = true;
extern int                   btn_Offset_x      = 204;                             //btn__x
extern int                   btn_Offset_y      = 20;                              //btn__y
extern int                   btn_Width         = 65;                          //btn__width
extern int                   btn_Height        = 20;                         //btn__height
extern int                   btn_FontSize      = 10;         
input bool                   inpSelection      = false;          // Highlight to move             //btn__font size
//extern ENUM_BASE_CORNER      btn_Corner        = CORNER_LEFT_UPPER;
extern bool                  Interpolate       = true;
//template code end1

extern string                TimeFrameNote1="input 0 for Current Timeframe, 1 for 1MIN, 5 for 5MIN";
extern string                TimeFrameNote2="15 for 15MIN, 30 for 30MIN, 60 for 1H";
extern string                TimeFrameNote3="240 for 4H, 1440 for D1, 10080 for W1, 43200 for MN1";
string DisplayID = "On Chart Wpr";

double MiddleLine[],UpperBand1[],LowerBand2[],Buffer4[],Buffer4Da[],Buffer4Db[],upArr1[],dnArr1[],upArr2[],dnArr2[],trend[], slope[], UpperBand2[], LowerBand1[];

string indicatorFileName;
bool   returnBars, calculateValue;
int    timeFrame, atrTimeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int OnInit()
{
   if (ObjectFind(DisplayID)!=0)
   {
      ObjectCreate(ChartID(),DisplayID,OBJ_BUTTON,0,0,0);
         ObjectSetString( ChartID(),DisplayID,OBJPROP_TEXT,"WPR on");
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_FONTSIZE,btn_FontSize);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_CORNER,0);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_COLOR,clrWhite);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_BGCOLOR,clrDimGray);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_YDISTANCE,btn_Offset_y);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_XDISTANCE,btn_Offset_x);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_XSIZE,btn_Width);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_YSIZE,btn_Height);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_SELECTABLE,inpSelection);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_SELECTED,inpSelection);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_HIDDEN,true);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_STATE,true);
   }


   IndicatorBuffers(14);
   SetIndexBuffer(0, MiddleLine); 
   SetIndexBuffer(1, UpperBand1); 
   SetIndexBuffer(2, UpperBand2); 
   SetIndexBuffer(3, LowerBand1); 
   SetIndexBuffer(4, LowerBand2); 
   SetIndexBuffer(5, Buffer4);    
   SetIndexBuffer(6, Buffer4Da);
   SetIndexBuffer(7, Buffer4Db);
   SetIndexBuffer(8, upArr1);   
   SetIndexBuffer(9, dnArr1);   
   SetIndexBuffer(10,upArr2);   
   SetIndexBuffer(11,dnArr2);   
   SetIndexBuffer(12,slope);
   SetIndexBuffer(13,trend);
   
   if (GetButtonState(DisplayID)!="off")
   {
      SetIndexStyle(0, DRAW_LINE); SetIndexLabel (0, "Middle Line"); 
      SetIndexStyle(1, DRAW_LINE); SetIndexLabel (1, "Upper Band 1");
      SetIndexStyle(2, DRAW_LINE); SetIndexLabel (2, "Upper Band 2");
      SetIndexStyle(3, DRAW_LINE); SetIndexLabel (3, "Lower Band 1");
      SetIndexStyle(4, DRAW_LINE); SetIndexLabel (4, "Lower Band 2");
      SetIndexStyle(5, DRAW_LINE); SetIndexLabel (5, "WPR ("+IntegerToString(WprPeriod)+")");
      SetIndexStyle(6, DRAW_LINE);
      SetIndexStyle(7, DRAW_LINE);
      SetIndexStyle(8, DRAW_ARROW,EMPTY,arrowsSize,arrowsUpColor); SetIndexArrow(8, arrowsUpCode);
      SetIndexStyle(9, DRAW_ARROW,EMPTY,arrowsSize,arrowsDnColor); SetIndexArrow(9, arrowsDnCode);
      SetIndexStyle(10,DRAW_ARROW,EMPTY,arrowsSize,arrowsUpColor); SetIndexArrow(10,arrowsUpCode);
      SetIndexStyle(11,DRAW_ARROW,EMPTY,arrowsSize,arrowsDnColor); SetIndexArrow(11,arrowsDnCode); 
    }
    else for (int i=0; i<11; i++) SetIndexStyle(i,DRAW_NONE);

        
         timeFrame    = stringToTimeFrame(TimeFrame);
         atrTimeFrame = PERIOD_H4;
              switch (timeFrame)
               {
                 case PERIOD_M1:  atrTimeFrame = PERIOD_H1;  break;
                 case PERIOD_M5:  atrTimeFrame = PERIOD_H4;  break;
                 case PERIOD_M15: atrTimeFrame = PERIOD_H4;  break;
                 case PERIOD_M30: atrTimeFrame = PERIOD_D1;  break;
                 case PERIOD_H1:  atrTimeFrame = PERIOD_D1;  break;
                 case PERIOD_H4:  atrTimeFrame = PERIOD_D1;  break;
                 case PERIOD_D1:  atrTimeFrame = PERIOD_W1;  break;
                 case PERIOD_W1:  atrTimeFrame = PERIOD_MN1; break;
                 default:         atrTimeFrame = PERIOD_H4;
               }
               
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         
   IndicatorShortName(timeFrameToString(timeFrame)+"   %R");
   return(0);
}
void OnDeinit(const int reason)
{ 
   if (!returnBars)
      switch(reason)
      {
         case REASON_PARAMETERS  :
         case REASON_CHARTCHANGE :
         case REASON_RECOMPILE   :
         case REASON_CLOSE       : break;
         default :
         {
            ObjectDelete(DisplayID);
         }                  
      }
}

void OnChartEvent(const int id, const long& lparam, const double& dparam, const string& sparam)
{
   static string prevState ="";
   if (id==CHARTEVENT_OBJECT_CLICK && sparam==DisplayID)
   {
      string newState = GetButtonState(DisplayID);
         if (newState!=prevState)
         if (newState=="off")
         { SetIndexStyle(0,DRAW_NONE); SetIndexStyle(1,DRAW_NONE); SetIndexStyle(2, DRAW_NONE); SetIndexStyle(3, DRAW_NONE); 
           SetIndexStyle(4,DRAW_NONE); SetIndexStyle(5,DRAW_NONE); SetIndexStyle(6, DRAW_NONE); SetIndexStyle(7, DRAW_NONE); 
           SetIndexStyle(8,DRAW_NONE); SetIndexStyle(9,DRAW_NONE); SetIndexStyle(10,DRAW_NONE); SetIndexStyle(11,DRAW_NONE); 
           prevState=newState; 
         }
         else  
         { SetIndexStyle(0,DRAW_LINE);  SetIndexStyle(1,DRAW_LINE);  SetIndexStyle(2, DRAW_LINE); SetIndexStyle(3, DRAW_LINE); 
           SetIndexStyle(4,DRAW_LINE);  SetIndexStyle(5,DRAW_LINE);  SetIndexStyle(6, DRAW_LINE); SetIndexStyle(7, DRAW_LINE); 
           SetIndexStyle(8,DRAW_ARROW); SetIndexStyle(9,DRAW_ARROW); SetIndexStyle(10,DRAW_ARROW);SetIndexStyle(11,DRAW_ARROW); 
           prevState=newState; 
         }
         ObjectSetString(ChartID(),DisplayID,OBJPROP_TEXT,"WPR"+newState);
   }
}  

//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { MiddleLine[0] = MathMin(limit+1,Bars-1); return(0); }
      
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      if (MultiColor && slope[limit]==-1) CleanPoint(limit,Buffer4Da,Buffer4Db);
      for (int i=limit; i>=0; i--) 
      {
         int r = iBarShift(NULL,atrTimeFrame,Time[i]);
            double avgRange = iATR(NULL,atrTimeFrame,AtrLength,r);

            double maValue  = iDSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,SmoothDouble,i,0);
            
            double wprValue;
            double hi = High[iHighest(NULL,0,MODE_HIGH,WprPeriod,i)];
            double lo =  Low[iLowest (NULL,0,MODE_LOW, WprPeriod,i)];
            if (hi!=lo)      
                 wprValue = iDSmooth(-100*(hi-Close[i])/(hi-lo),WprPeriod,WprPhase,WprDouble,i,20);
            else wprValue = iDSmooth(0                         ,WprPeriod,WprPhase,WprDouble,i,20); 
               
            MiddleLine[i] = maValue;
            UpperBand1[i] = maValue+(avgRange*(overBought+50)/100);
            LowerBand2[i] = maValue-(avgRange*(-50-overSold)/100);
            UpperBand2[i] = maValue+(avgRange*(overBought+45)/100);
            LowerBand1[i] = maValue-(avgRange*(-45-overSold)/100);
            Buffer4[i]    = maValue+(wprValue+50)/100*avgRange;
            
            //
            //
            //
            //
            //
            
            Buffer4Da[i] = Buffer4Db[i] = EMPTY_VALUE;
            upArr1[i] = dnArr1[i] = EMPTY_VALUE;
            upArr2[i] = dnArr2[i] = EMPTY_VALUE;
            slope[i] = slope[i+1];
            trend[i] = trend[i+1];
            if (Buffer4[i]<Buffer4[i+1])    slope[i] = -1;
            if (Buffer4[i]>Buffer4[i+1])    slope[i] =  1;
            if (Buffer4[i]>MiddleLine[i])   trend[i] =  1;
            if (Buffer4[i]<MiddleLine[i])   trend[i] = -1;
            if (MultiColor && slope[i] == -1) PlotPoint(i,Buffer4Da,Buffer4Db,Buffer4);
            if (arrowsVisible)
            {
              if (arrowsOnSlope && slope[i]!= slope[i+1])
              {
                 if (slope[i] ==  1) upArr1[i] = fmin(Buffer4[i],Low[i] )-iATR(NULL,0,15,i)*arrowsUpperGap;
                 if (slope[i] == -1) dnArr1[i] = fmax(Buffer4[i],High[i])+iATR(NULL,0,15,i)*arrowsLowerGap;
              } 
              if (arrowsOnMaCross && trend[i]!= trend[i+1])
              {
                 if (trend[i] ==  1) upArr2[i] = fmin(Buffer4[i],Low[i] )-iATR(NULL,0,15,i)*arrowsUpperGap;
                 if (trend[i] == -1) dnArr2[i] = fmax(Buffer4[i],High[i])+iATR(NULL,0,15,i)*arrowsLowerGap;
              }            
            }
     } 
      
     //
     //
     //
     //
     //
         
     if (alertsOn)
     {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        static datetime time1 = 0;
        static string   mess1 = "";
        if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
        {
           if (slope[whichBar] ==  1 ) doAlert(time1,mess1,whichBar,"sloping up");
           if (slope[whichBar] == -1 ) doAlert(time1,mess1,whichBar,"sloping down");
        }         
        static datetime time2 = 0;
        static string   mess2 = "";
        if (alertsOnMaCross && trend[whichBar] != trend[whichBar+1])
        {
           if (trend[whichBar] ==  1 ) doAlert(time2,mess2,whichBar,"crossing Ma up");
           if (trend[whichBar] == -1 ) doAlert(time2,mess2,whichBar,"crossing Ma down");
        }         
     }          
   return(0);
   } 
        
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (MultiColor && slope[limit]==-1) CleanPoint(limit,Buffer4Da,Buffer4Db);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = y;
      if (arrowsOnFirst)
            {  if (i<Bars-1) x = iBarShift(NULL,timeFrame,Time[i+1]);               }
      else  {  if (i>0)      x = iBarShift(NULL,timeFrame,Time[i-1]); else x = -1;  }
         Buffer4Da[i]  = Buffer4Db[i] = EMPTY_VALUE; //make mtf lines smoother
         MiddleLine[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,0,y);
         UpperBand1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,1,y);
         UpperBand2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,2,y);
         LowerBand1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,3,y);
         LowerBand2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,4,y);
         Buffer4[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,5,y); 
         slope[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,12,y); 
         trend[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,13,y); 
      if (x!=y)
      {
         upArr1[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,8,y);
         dnArr1[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,9,y); 
         upArr2[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,10,y); 
         dnArr2[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPhase,WprDouble,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,overBought,overSold,note9,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnMaCross,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsSize,note10,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnMaCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,MultiColor,btn_Offset_x,btn_Offset_y,btn_Width,btn_Height,btn_FontSize,inpSelection,11,y); 
      }
      else
      {
         upArr1[i] = dnArr1[i] = EMPTY_VALUE;
         upArr2[i] = dnArr2[i] = EMPTY_VALUE; 
      }
         
           
            
//
//
//               
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         //
         //
         //
         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               MiddleLine[i+k] = MiddleLine[i] + (MiddleLine[i+n] - MiddleLine[i]) * k/n;
               UpperBand1[i+k] = UpperBand1[i] + (UpperBand1[i+n] - UpperBand1[i]) * k/n;
               UpperBand2[i+k] = UpperBand2[i] + (UpperBand2[i+n] - UpperBand2[i]) * k/n;
               LowerBand1[i+k] = LowerBand1[i] + (LowerBand1[i+n] - LowerBand1[i]) * k/n;
               LowerBand2[i+k] = LowerBand2[i] + (LowerBand2[i+n] - LowerBand2[i]) * k/n;
               Buffer4[i+k]    = Buffer4[i]    + (Buffer4[i+n]    - Buffer4[i])    * k/n;             
           }          
    }
    for (i=limit;i>=0;i--) if (MultiColor && slope[i] == -1) PlotPoint(i,Buffer4Da,Buffer4Db,Buffer4);  
return(0);
}
//+------------------------------------------------------------------+
string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
//+------------------------------------------------------------------+
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
//+------------------------------------------------------------------+
string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}
//+------------------------------------------------------------------+
double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}
//+------------------------------------------------------------------+
double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
           
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   return(wrk[r][4+s]);
}
//+------------------------------------------------------------------+
void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}
//+------------------------------------------------------------------+
void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2]   == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," OnChart_WPRsmooth ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," OnChart_WPRsmooth "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//
//
//

string GetButtonState(string whichbutton)
{
      bool selected = ObjectGetInteger(ChartID(),whichbutton,OBJPROP_STATE);
      if (selected) { return ("on");  } 
      else          { return ("off"); }
}

