// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=68338

//+------------------------------------------------------------------+
//|                               Copyright © 2019, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------+
//|                                Patreon :  https://goo.gl/GdXWeN  |
//+------------------------------------------------------------------+
// modified by banzai from Mario Jemic template
// July 27th, 2020
// not for sale, rent, auction, nor lease
//+------------------------------------------------------------------+
//|                                                   FiboPiv_v2.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"
//----
#property indicator_chart_window
extern string             LabelFont             = "Arial";
extern int                LabelFontSize         = 8;
extern int                ShiftLabel            = 10;//Label Shift +move right -move left
extern string             note1                 = "------------------------------";
extern color              Resistance3Color      = clrLime;
extern color              Resistance3Label      = clrLime;
extern ENUM_LINE_STYLE    Resistance3Style      = STYLE_DASH;
extern int                Resistance3Width      = 1;
extern string             note2                 = "------------------------------";
extern color              Resistance2Color      = clrGreen;
extern color              Resistance2Label      = clrGreen;
extern ENUM_LINE_STYLE    Resistance2Style      = STYLE_DASH;
extern int                Resistance2Width      = 1;
extern string             note3                 = "------------------------------";
extern color              Resistance1Color      = clrDarkGreen;
extern color              Resistance1Label      = clrDarkGreen;
extern ENUM_LINE_STYLE    Resistance1Style      = STYLE_DASH;
extern int                Resistance1Width      = 1;
extern string             note4                 = "------------------------------";
extern color              PivotColor            = clrBlue;
extern color              PivotLabel            = clrBlue;
extern ENUM_LINE_STYLE    PivotStyle            = STYLE_SOLID;
extern int                PivotWidth            = 1;
extern string             note5                 = "------------------------------";
extern color              Support1Color         = clrMaroon;
extern color              Support1Label         = clrMaroon;
extern ENUM_LINE_STYLE    Support1Style         = STYLE_DASH;
extern int                Support1Width         = 1;
extern string             note6                 = "------------------------------";
extern color              Support2Color         = clrCrimson;
extern color              Support2Label         = clrCrimson;
extern ENUM_LINE_STYLE    Support2Style         = STYLE_DASH;
extern int                Support2Width         = 1;
extern string             note7                 = "------------------------------";
extern color              Support3Color         = clrRed;
extern color              Support3Label         = clrRed;
extern ENUM_LINE_STYLE    Support3Style         = STYLE_DASH;
extern int                Support3Width         = 1;

extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; // chart btn_corner for anchoring
extern string             btn_text              = "Fibo";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                             //btn__font size
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 20;                                     //btn__x
extern int                button_y              = 13;                                     //btn__y
extern int                btn_Width             = 60;                                 //btn__width
extern int                btn_Height            = 20;                                //btn__height
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;
//template code end1

//+------------------------------------------------------------------+
string GenerateIndicatorName(const string target)
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------+
string buttonId;

int init()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

// put init() here
   
   ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + "CloseButton";
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);
   
   return 0;
}
//+------------------------------------------------------------------+
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
   ObjectDelete("S1");
   ObjectDelete("S2");
   ObjectDelete("S3");
   ObjectDelete("R1");
   ObjectDelete("R2");
   ObjectDelete("R3");
   ObjectDelete("PIVOT");
   ObjectDelete("Support 1");
   ObjectDelete("Support 2");
   ObjectDelete("Support 3");
   ObjectDelete("Pivot level");
   ObjectDelete("Resistance 1");
   ObjectDelete("Resistance 2");
   ObjectDelete("Resistance 3");
   Comment(" ");
   return 0;
}
//+------------------------------------------------------------------+
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(0, buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------+
int start()
{
   handleButtonClicks();

   recalc = false;

   double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
   ArrayCopyRates(rates,Symbol(),PERIOD_D1);
//----
   if(DayOfWeek()==1)
     {
      if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1))==5)
        {
         yesterday_close= rates[1][4];
         yesterday_high = rates[1][3];
         yesterday_low=rates[1][2];
        }
      else
        {
         for(int d=5;d>=0;d--)
           {
            if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d))==5)
              {
               yesterday_close= rates[d][4];
               yesterday_high = rates[d][3];
               yesterday_low=rates[d][2];
              }

           }
        }
     }
   else
     {
      yesterday_close= rates[1][4];
      yesterday_high = rates[1][3];
      yesterday_low=rates[1][2];
     }
//---- Calculate Pivots
   Comment("\nYesterday quotations:\nH ",yesterday_high,"\nL ",yesterday_low,"\nC ",yesterday_close);
   double R=yesterday_high-yesterday_low;//range
   double p=(yesterday_high+yesterday_low+yesterday_close)/3;// Standard Pivot
   double r3 = p + (R * 1.000);
   double r2 = p + (R * 0.618);
   double r1 = p + (R * 0.382);
   double s1 = p - (R * 0.382);
   double s2 = p - (R * 0.618);
   double s3 = p - (R * 1.000);
//----
      if (show_data)
      {
         ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
         drawLine(r3,"R3",Resistance3Color,Resistance3Style,Resistance3Width);
         drawLabel("Resistance 3",r3,Resistance3Label);
         drawLine(r2,"R2",Resistance2Color,Resistance2Style,Resistance2Width);
         drawLabel("Resistance 2",r2,Resistance2Label);
         drawLine(r1,"R1",Resistance1Color,Resistance1Style,Resistance1Width);
         drawLabel("Resistance 1",r1,Resistance1Label);
         
         drawLine(p,"PIVOT",PivotLabel,PivotStyle,PivotWidth);
         drawLabel("Pivot level",p,PivotLabel);
         
         drawLine(s1,"S1",Support1Color,Support1Style,Support1Width);
         drawLabel("Support 1",s1,Support1Label);
         drawLine(s2,"S2",Support2Color,Support2Style,Support2Width);
         drawLabel("Support 2",s2,Support2Label);
         drawLine(s3,"S3",Support3Color,Support3Style,Support3Width);
         drawLabel("Support 3",s3,Support3Label);
      }
      else
      {
         ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
         ObjectDelete("S1");
         ObjectDelete("S2");
         ObjectDelete("S3");
         ObjectDelete("R1");
         ObjectDelete("R2");
         ObjectDelete("R3");
         ObjectDelete("PIVOT");
         ObjectDelete("Support 1");
         ObjectDelete("Support 2");
         ObjectDelete("Support 3");
         ObjectDelete("Pivot level");
         ObjectDelete("Resistance 1");
         ObjectDelete("Resistance 2");
         ObjectDelete("Resistance 3");
         Comment(" ");
      }
   
   return 0;
}
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
  {
   if(ObjectFind(name)!=0)
     {
      if(Bars<10) return;
      ObjectCreate(name,OBJ_TEXT,0,Time[10]+Period()*60*ShiftLabel,lvl);
      ObjectSetText(name,name,LabelFontSize,LabelFont,EMPTY);
      ObjectSet(name,OBJPROP_COLOR,Color);
     }
   else
     {
      if(Bars<10) return;
      ObjectMove(name,0,Time[10]+Period()*60*ShiftLabel,lvl);
     }
  }
//+------------------------------------------------------------------+
void drawLine(double lvl,string name,color Col,int type, int myWidth)
  {
   if(ObjectFind(name)!=0)
     {
      ObjectCreate(name,OBJ_HLINE,0,Time[0],lvl,Time[0],lvl);
      ObjectSet(name,OBJPROP_STYLE,type);
      ObjectSet(name,OBJPROP_COLOR,Col);
      ObjectSet(name,OBJPROP_WIDTH,myWidth);
     }
   else
     {
      ObjectDelete(name);
      ObjectCreate(name,OBJ_HLINE,0,Time[0],lvl,Time[0],lvl);
      ObjectSet(name,OBJPROP_STYLE,type);
      ObjectSet(name,OBJPROP_COLOR,Col);
      ObjectSet(name,OBJPROP_WIDTH,myWidth);
     }
  }
//+--------------------------------------------------------------------+

