// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=68338

//+------------------------------------------------------------------+
//|                               Copyright © 2019, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------+
//|                                Patreon :  https://goo.gl/GdXWeN  |
//|                    BitCoin : 15VCJTLaz12Amr7adHSBtL9v8XomURo9RF  |
//|               BitCoin Cash : 1BEtS465S3Su438Kc58h2sqvVvHK9Mijtg  |
//|           Ethereum : 0x8C110cD61538fb6d7A2B47858F0c0AaBd663068D  |
//|                   LiteCoin : LLU8PSY2vsq7B9kRELLZQcKf5nJQrdeqwD  |
//+------------------------------------------------------------------+
// modified by banzai from Mario Jemic template @
// http://fxcodebase.com/code/viewtopic.php?f=38&t=69820
// July 10th, 2020
// not for sale, rent, auction, nor lease
//+------------------------------------------------------------------+
//|                                                   MA Chanels.mq4 |
//|                                                           °njel° |
//|                                                     iamnotlinked |
//+------------------------------------------------------------------+
#property copyright "°njel°"

#property indicator_chart_window
#property indicator_buffers 8

#property indicator_color1 clrRed
#property indicator_color2 clrOrange
#property indicator_color3 clrDarkGoldenrod
#property indicator_color4 clrDimGray
#property indicator_color5 clrDimGray
#property indicator_color6 clrDarkGoldenrod
#property indicator_color7 clrOrange
#property indicator_color8 clrRed
//---- input parameters
extern int                 MaxBarsToDisplay      = 500;
extern int                 MAPeriod              = 21;
extern ENUM_MA_METHOD      MAMethod              = MODE_LWMA;
extern ENUM_APPLIED_PRICE  MAPrice               = PRICE_CLOSE; // Price to use 
extern int                 FontSize              = 10;
extern string              FontName              = "Arial";
//extern color               FontColor             = clrCrimson;

extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; // chart btn_corner for anchoring
extern string             btn_text              = "LWMA Channel";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 9;                             //btn__font size
extern color              btn_text_color        = clrWhite;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 80;                                     //btn__x
extern int                button_y              = 73;                                     //btn__y
extern int                btn_Width             = 90;                                 //btn__width
extern int                btn_Height            = 20;                                //btn__height
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;
//template code end1
double Inc0 = 0.0000,Inc1 = 0.0000, Inc2 = 0.0000, Inc3 = 0.0000, max =0, min =0, ExtMapBuffer1[], ExtMapBuffer2[], ExtMapBuffer3[], ExtMapBuffer4[], ExtMapBuffer5[], ExtMapBuffer6[], ExtMapBuffer7[], ExtMapBuffer8[];
//+------------------------------------------------------------------+
string GenerateIndicatorName(const string target)
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------+
string buttonId;

int init()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

// put init() here
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel(0,"61.8%");
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel(1,"50%");   
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexLabel(2,"38.2%");   
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexLabel(3,"23.5%");   
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexLabel(4,"23.5%");      
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexLabel(5,"38.2%");      
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexLabel(6,"50%");   
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexLabel(7,"61.8%");   
   ObjectCreate ("LWMAForex1", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("LWMAForex1", "61.8%",FontSize,FontName,indicator_color1);
   ObjectCreate ("LWMAForex2", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("LWMAForex2", "50%",FontSize,FontName,indicator_color2);
   ObjectCreate ("LWMAForex3", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("LWMAForex3", "38.2%",FontSize,FontName,indicator_color3);
   ObjectCreate ("LWMAForex4", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("LWMAForex4", "23.5%",FontSize,FontName,indicator_color4);
   ObjectCreate ("LWMAForex5", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("LWMAForex5", "23.5%",FontSize,FontName,indicator_color5);
   ObjectCreate ("LWMAForex6", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("LWMAForex6", "38.2%",FontSize,FontName,indicator_color6);
   ObjectCreate ("LWMAForex7", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("LWMAForex7", "50%",FontSize,FontName,indicator_color7);
   ObjectCreate ("LWMAForex8", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("LWMAForex8", "61.8%",FontSize,FontName,indicator_color8);
   for (int banzai=0; banzai<8; banzai++) SetIndexStyle(banzai,DRAW_LINE);

   ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + "CloseButton";
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);
   
   return 0;
}
//+------------------------------------------------------------------+
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
            max =0;
            min =0;
            ObjectDelete("LWMAForex1");
            ObjectDelete("LWMAForex2");
            ObjectDelete("LWMAForex3");
            ObjectDelete("LWMAForex4");
            ObjectDelete("LWMAForex5");
            ObjectDelete("LWMAForex6");
            ObjectDelete("LWMAForex7");
            ObjectDelete("LWMAForex8");
   return 0;
}
//+------------------------------------------------------------------+
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(0, buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;
   max =0;
   min =0;
   
   
//   if (iBars(NULL,0) < MaxBarsToDisplay)
//      MaxBarsToDisplay = iBars(NULL,0) -MAPeriod-1 ;
      
   for (int i =MaxBarsToDisplay; i>=0; i--)
   {
   
      double m = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i);
      double top = High[i] - m;      
      if (top > max)
         max = top;
      
      double bottom = Low[i] - m;      
      if (bottom < min)
         min = bottom;
      
   }
   
   if (MathAbs(max) >  MathAbs(min))
      Inc3 = max;
   else
      Inc3 = min;
      
      
       
      Inc2 = Inc3*0.618;
      Inc1 = Inc3*0.5;
      Inc0 = Inc3*0.236;
      Inc3 = Inc3*0.382;
   

   for (i =MaxBarsToDisplay; i>=0; i--)
   {
      ExtMapBuffer1[i] = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i) + Inc2;
      ExtMapBuffer2[i] = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i) + Inc1;
      ExtMapBuffer3[i] = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i) + Inc3;
      ExtMapBuffer4[i] = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i) + Inc0;
      ExtMapBuffer5[i] = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i) - Inc0;
      ExtMapBuffer6[i] = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i) - Inc3;
      ExtMapBuffer7[i] = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i) - Inc1;
      ExtMapBuffer8[i] = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i) - Inc2;
   }
   ObjectMove("LWMAForex1", 0, Time[0],ExtMapBuffer1[0]);
   ObjectMove("LWMAForex2", 0, Time[0],ExtMapBuffer2[0]);
   ObjectMove("LWMAForex3", 0, Time[0],ExtMapBuffer3[0]);
   ObjectMove("LWMAForex4", 0, Time[0],ExtMapBuffer4[0]);
   ObjectMove("LWMAForex5", 0, Time[0],ExtMapBuffer5[0]);
   ObjectMove("LWMAForex6", 0, Time[0],ExtMapBuffer6[0]);
   ObjectMove("LWMAForex7", 0, Time[0],ExtMapBuffer7[0]);
   ObjectMove("LWMAForex8", 0, Time[0],ExtMapBuffer8[0]);

      if (show_data)
      {
      /*
       ObjectSetText("LWMAForex1", "61.8%",FontSize,FontName,FontColor);
       ObjectSetText("LWMAForex2", "50%",  FontSize,FontName,FontColor);
       ObjectSetText("LWMAForex3", "38.2%",FontSize,FontName,FontColor);
       ObjectSetText("LWMAForex4", "23.5%",FontSize,FontName,FontColor);
       ObjectSetText("LWMAForex5", "23.5%",FontSize,FontName,FontColor);
       ObjectSetText("LWMAForex6", "38.2%",FontSize,FontName,FontColor);
       ObjectSetText("LWMAForex7", "50%",  FontSize,FontName,FontColor);
       ObjectSetText("LWMAForex8", "61.8%",FontSize,FontName,FontColor);
       */
       ObjectSetText("LWMAForex1", "61.8%",FontSize,FontName,indicator_color1);
       ObjectSetText("LWMAForex2", "50%",  FontSize,FontName,indicator_color2);
       ObjectSetText("LWMAForex3", "38.2%",FontSize,FontName,indicator_color3);
       ObjectSetText("LWMAForex4", "23.5%",FontSize,FontName,indicator_color4);
       ObjectSetText("LWMAForex5", "23.5%",FontSize,FontName,indicator_color5);
       ObjectSetText("LWMAForex6", "38.2%",FontSize,FontName,indicator_color6);
       ObjectSetText("LWMAForex7", "50%",  FontSize,FontName,indicator_color7);
       ObjectSetText("LWMAForex8", "61.8%",FontSize,FontName,indicator_color8);
      for (int banzai=0; banzai<8; banzai++) SetIndexStyle(banzai,DRAW_LINE);
      }
      else
      {
       for (banzai=0; banzai<8; banzai++)
           SetIndexStyle(banzai,DRAW_NONE);
       ObjectSetText("LWMAForex1", "",FontSize,FontName,clrNONE);
       ObjectSetText("LWMAForex2", "",FontSize,FontName,clrNONE);
       ObjectSetText("LWMAForex3", "",FontSize,FontName,clrNONE);
       ObjectSetText("LWMAForex4", "",FontSize,FontName,clrNONE);
       ObjectSetText("LWMAForex5", "",FontSize,FontName,clrNONE);
       ObjectSetText("LWMAForex6", "",FontSize,FontName,clrNONE);
       ObjectSetText("LWMAForex7", "",FontSize,FontName,clrNONE);
       ObjectSetText("LWMAForex8", "",FontSize,FontName,clrNONE);
      }
   return 0;
}
//+------------------------------------------------------------------+

