// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=68338

//+------------------------------------------------------------------+
//|                               Copyright © 2019, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------+
//|                                Patreon :  https://goo.gl/GdXWeN  |
//|                    BitCoin : 15VCJTLaz12Amr7adHSBtL9v8XomURo9RF  |
//|               BitCoin Cash : 1BEtS465S3Su438Kc58h2sqvVvHK9Mijtg  |
//|           Ethereum : 0x8C110cD61538fb6d7A2B47858F0c0AaBd663068D  |
//|                   LiteCoin : LLU8PSY2vsq7B9kRELLZQcKf5nJQrdeqwD  |
//+------------------------------------------------------------------+
// modified by banzai from Mario Jemic template 
// July 23rd, 2020
// not for sale, rent, auction, nor lease
//+------------------------------------------------------------------+
//|                                 Stoch Candle OverBought-Sold.mq4 |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                 StochCandles.mq4 |
//| Colored Candles, based on Stochastic Signal.							|
//+------------------------------------------------------------------+
#property copyright "Copyright © 2007, Christof Risch (iya)"
#property link      "http://www.forexfactory.com/showthread.php?t=13321"
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 clrGreen
#property indicator_color2 clrRed
#property indicator_color3 clrGreen
#property indicator_color4 clrRed
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3

#property indicator_color5 clrOrange
#property indicator_color6 clrOrange
#property indicator_color7 clrOrange
#property indicator_color8 clrOrange
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 3
#property indicator_width8 3

//---- stoch settings
extern string note1 = "Stochastic settings";
extern double	Stoch_K			= 14.0,
					Stoch_D			= 3.0,
					Stoch_Slowing	= 3.0,
					Upper_Level		= 80,
					Lower_Level		= 20;

//---- input parameters
extern color	BarUp				= clrGreen,
					BarDown			= clrRed,
					BullCandle		= clrGreen,
					BearCandle		= clrRed,
					BarUp2			= clrOrange,
					BarDown2			= clrOrange,
					MedCandle      = clrOrange,
					MedCandle2     = clrOrange;
extern int		BarWidth			= 1,
					CandleWidth		= 3,
					BarWidth2		= 1,
					CandleWidth2	= 3;

extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; // chart btn_corner for anchoring
extern string             btn_text              = "Stoch";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                             //btn__font size
extern color              btn_text_color        = clrWhite;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 20;                                     //btn__x
extern int                button_y              = 13;                                     //btn__y
extern int                btn_Width             = 60;                                 //btn__width
extern int                btn_Height            = 20;                                //btn__height
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;
//template code end1
double Buffer1[], Buffer2[], Buffer3[], Buffer4[], Buffer5[], Buffer6[], Buffer7[], Buffer8[];
//+------------------------------------------------------------------+
string GenerateIndicatorName(const string target) //don't change anything here
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------+
string buttonId;

int init()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

// put init() here
	SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth,BarUp);
	SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth,BarDown);
	SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth,BullCandle);
	SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth,BearCandle);
	SetIndexBuffer(0, Buffer1);
	SetIndexBuffer(1, Buffer2);
	SetIndexBuffer(2, Buffer3);
	SetIndexBuffer(3, Buffer4);
	
	SetIndexStyle(4,DRAW_HISTOGRAM,0,BarWidth2,BarUp2);
	SetIndexStyle(5,DRAW_HISTOGRAM,0,BarWidth2,BarDown2);
	SetIndexStyle(6,DRAW_HISTOGRAM,0,CandleWidth2,MedCandle );
	SetIndexStyle(7,DRAW_HISTOGRAM,0,CandleWidth2,MedCandle2 );
	SetIndexBuffer(4, Buffer5);
	SetIndexBuffer(5, Buffer6);
	SetIndexBuffer(6, Buffer7);
	SetIndexBuffer(7, Buffer8);

   ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + "StochCandle2020";
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);
   
   return 0;
}
//+------------------------------------------------------------------+
//don't change anything here
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);

//put deinit() here

   return 0;
}
//+------------------------------------------------------------------+
//don't change anything here
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(0, buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------+
double Stoch_Main  	(int i = 0)	{return(iStochastic(NULL,0,Stoch_K,Stoch_D,Stoch_Slowing,MODE_SMA,0,MODE_MAIN,  i));}
//+------------------------------------------------------------------+
bool IsMedCandle(int i = 0)
{
	if(i>=Bars)
		return(false);

	if(High[i]==Low[i])
		return(IsMedCandle(i+1));

	return(Buffer5[i]==High[i] && Buffer6[i]==Low[i]);
}

//+------------------------------------------------------------------+
void SetBullCandle(int i = 0)
{
	Buffer1[i] = High[i];
	Buffer2[i] = Low[i];
	Buffer3[i] = MathMax(Open[i],Close[i]);
	Buffer4[i] = MathMin(Open[i],Close[i]);
}

//+------------------------------------------------------------------+
void SetBearCandle(int i = 0)
{
	Buffer1[i] = Low[i];
	Buffer2[i] = High[i];
	Buffer3[i] = MathMin(Open[i],Close[i]);
	Buffer4[i] = MathMax(Open[i],Close[i]);
}
//+------------------------------------------------------------------+
void SetMedCandle(int i = 0)
{
	Buffer5[i] = Low[i];
	Buffer6[i] = High[i];
	Buffer7[i] = MathMin(Open[i],Close[i]);
	Buffer8[i] = MathMax(Open[i],Close[i]);
}

//+------------------------------------------------------------------+
void SetMedCandle2(int i = 0)
{
	Buffer5[i] = Low[i];
	Buffer6[i] = High[i];
	Buffer7[i] = MathMin(Open[i],Close[i]);
	Buffer8[i] = MathMax(Open[i],Close[i]);
}
//+------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;
	for(int i = MathMax(Bars-1-IndicatorCounted(),1); i >= 0; i--)
	{
		double	stochMain	= Stoch_Main(i),
				
					Med = Stoch_Main(i);
					
		bool		bull = (stochMain < Lower_Level),
				bear = (stochMain > Upper_Level	);
					Med =  ((stochMain < Upper_Level	)&&(stochMain > 20));


		if(!bull && !bear && !Med)
		{
				bull = (stochMain < Lower_Level);
			bear = (stochMain > Upper_Level	);
			Med =  ((stochMain < Upper_Level	)&&(stochMain > Lower_Level));
		}

		if			(bull)					SetBullCandle(i);
		else if	(bear)					SetBearCandle(i);
		
		else if	(IsMedCandle(i+1))	SetMedCandle(i);
		else									SetMedCandle2(i);
	}

      if (show_data)
      {     
       for (int banzai=0; banzai<8; banzai++)
           SetIndexStyle(banzai,DRAW_HISTOGRAM);
      }
      else
      {
       for (banzai=0; banzai<8; banzai++)
           SetIndexStyle(banzai,DRAW_NONE);
      }
   return 0;
}
//+------------------------------------------------------------------+
