// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=68338
// ma_with_button.mq4
//+------------------------------------------------------------------+
//|                               Copyright © 2020, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------+
//|                                Patreon :  https://goo.gl/GdXWeN  |
//+------------------------------------------------------------------+
// modified by banzai from Mario Jemic template 
// July 26th, 2020
// not for sale, rent, auction, nor lease
//+------------------------------------------------------------------+
//|                                                LSMA _rainbow.mq4 |
//|                                                             Swan |
//|                                  http://ruforum.forexpeoples.com |
//|                                                           eugenk |
//|                                     http://forum.mql4.com/ru/9154|
//|                                                       Dm_35 2008 |
//|                                         http://dimdimych.ucoz.ru |
//+------------------------------------------------------------------+
#property copyright "Dm_35"
#property link      "dm34@mail.ru"
#property indicator_chart_window

extern int KPeriod=10;

extern int Step=1;//øàã èçìåíåíèÿ KPeriod
extern int Count=70;//êîëè÷åñòâî ëèíèé
extern int Limit=400;//êîëè÷åñòâî áàðîâ äëÿ îòðèñîâêè

extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; // chart btn_corner for anchoring
extern string             btn_text              = "LSMA";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                             //btn__font size
extern color              btn_text_color        = clrWhite;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 20;                                     //btn__x
extern int                button_y              = 13;                                     //btn__y
extern int                btn_Width             = 60;                                 //btn__width
extern int                btn_Height            = 20;                                //btn__height
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;
//template code end1
int m;
string Name;
color Color=0;
int rainbow[10000];  //òóò õðàíèòñÿ ðàäóãà
int nRainbow;        //÷èñëî öâåòîâ ðàäóãè

//+------------------------------------------------------------------+
string GenerateIndicatorName(const string target) //don't change anything here
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------+
string buttonId;

int OnInit()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

// put init() here
   if(Count>70) Count=70;

   ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + "LSMArainbow2020";
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);
   
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//don't change anything here
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);

//put deinit() here
   DeleteLine();

	return(0);
}
//+------------------------------------------------------------------+
//don't change anything here
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(0, buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;
double ArrayMain[][50];
DeleteLine(); m=0;


   ArrayResize(ArrayMain,Limit);
   for(int i=0;i<Limit;i++)
      {
      for(int n=0;n<Count;n++)
         {
         ArrayMain[i][n]=3*iMA(NULL,0,KPeriod+n*Step,0,MODE_LWMA, PRICE_CLOSE,i)-
                         2*iMA(NULL,0,KPeriod+n*Step,0,MODE_SMA,  PRICE_CLOSE,i);
         }
      }
nRainbow=BuildRainbow();
int c;

   for(n=0;n<Count;n++)
      {
      for(i=0;i<Limit-1;i++)
         {
         c=GetRainbowColor(n);
         DrawLine(ArrayMain[i][n],ArrayMain[i+1][n],c,i);
         }
      }
WindowRedraw();

      if (show_data)
      {
WindowRedraw();
      }
      else
      {
   DeleteLine();
      }
   return(0);
}
//+------------------------------------------------------------------+
void DrawLine(double Var1,double Var2,int c,int i)
   {
   ObjectCreate("line"+m,OBJ_TREND,0,Time[i],Var1,Time[i+1],Var2);
   ObjectSet("line"+m,OBJPROP_RAY,false);
   ObjectSet("line"+m,OBJPROP_COLOR,c);
   m++;
   }
//+------------------------------------------------------------------+
void DeleteLine()
   {
   for(int i=0;i<m;i++)
   ObjectDelete("line"+i);
   }
//+------------------------------------------------------------------+
int GetRGB(int r, int g, int b)
{//ñòðîèò öâåò ïî êîìïîíåíòàì r, g, b
   return (256*(256*b + g) + r);
}
//+------------------------------------------------------------------+
int BuildRainbow()
{//ñòðîèò ðàäóãó, âîçâðàùàÿ ÷èñëî öâåòîâ
//âîçìîæíî Âû ïðèäóìàåòå áîëåå âûðàçèòåëüíóþ ïàëèòðó :)
   int r=255, g=0, b=0;
   int n=0;
   
   while(g !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      g++; n++;
   }   
   while(r !=0)
   {
      rainbow[n]=GetRGB(r, g, b);
      r--; n++;
   }
   while(b !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      b++; n++;
   }
   while(g !=0)
   {
      rainbow[n]=GetRGB(r, g, b);
      g--; n++;
   }
   while(r !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      r++; n++;
   }
   return (n);   
}
//+------------------------------------------------------------------+
int GetRainbowColor(int c)
{//Âûáèðàåò èç ðàäóãè îòìàñøòàáèðîâàííûé öâåò
   double k=nRainbow/Count;
   int n=c*k;
   return (rainbow[n]);
}
//+------------------------------------------------------------------+
